﻿using System.Diagnostics;
using System.Threading;
using System.Windows.Media;
using System.Xml;
using ff14bot;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;
using Clio.Utilities;
using System;
using System.Collections.Generic;
using System.IO;
using System.Configuration;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Timers;
using System.Windows.Forms;
using ff14bot.RemoteWindows;
using TreeSharp;

using Action = TreeSharp.Action;
using ff14bot.AClasses;

namespace BuyCoke
{
    public class BuyCoke : BotBase
    {
        private Composite _root;
		public Vector3 NpcLocation = new Vector3(-139.4786f, 4.1f, -106.8341f);
        public uint NpcId = 1002390;
			
		public bool FirstTime = true;
		public int buyCount = 0;
		public int buyMax = 200;
		public int Status = 0;
		
		public override string Name
        {
            get
			{

                return "BuyCoke";
            }
        }

		public static Version Version = new Version(1, 0, 0);
		
        public override void Start()
        {
            Navigator.PlayerMover = new SlideMover();
            Navigator.NavigationProvider = new GaiaNavigator();
			FirstTime = true;
			buyCount = 0;
            
            Logging.Write(Colors.SandyBrown, "[BuyCoke v" + Version.ToString() + "] Starting BuyCoke");
        }

	

		public override void Stop()
        {
            var gaiaNavigator = Navigator.NavigationProvider as GaiaNavigator;
            if (gaiaNavigator != null)
                gaiaNavigator.Dispose();
            Logging.Write(Colors.SandyBrown, "[BuyCoke v" + Version.ToString() + "] Stopping BuyCoke");
            Status = 0;
        }
		
		public override PulseFlags PulseFlags
        {
            get { return PulseFlags.All; }
        }

        public override bool RequiresProfile
        {
            get { return false; }
        }

        public override bool WantButton
        {
            get { return true; }
        }
		
		
		public override Composite Root
        {
            get
            {
                return _root ?? (_root =
                    new PrioritySelector(
						new Decorator(r => GrandCompanyExchangeWindow.IsOpen && buyCount >= buyMax,                                                          
							new Action(r =>
							{
								Logging.Write(Colors.SandyBrown, "[BuyCoke v" + Version.ToString() + "] Stopping.");
								GrandCompanyExchangeWindow.CloseWindow();	
								TreeRoot.Stop();									
								Status = 0;
							})    
                        ),
						new Decorator(r => GCESelectyesno.IsOpen,                                                          
							new Action(r =>
							{	
								GCESelectyesno.ClickOk();
								buyCount = buyCount+1;
								Status = 0;
							})    
                        ),
                        new Decorator(r => GrandCompanyExchangeWindow.IsOpen && FirstTime,
                            new Sequence(                                
                                new Action(r =>
                                {
                                    Logging.Write(Colors.SandyBrown, "[BuyCoke v" + Version.ToString() + "] Moving to Tabs.");
                                    GrandCompanyExchangeWindow.MoveToType();
									GrandCompanyExchangeWindow.MoveToTab();
									FirstTime = false;
									buyCount = 0;
                                    Status = 0;
                                }),
                                new Sleep(2)
                            )
                        ),
						new Decorator(r => GrandCompanyExchangeWindow.IsOpen && buyCount < buyMax && !GCESelectyesno.IsOpen,
                                                            
							new Action(r =>
							{
								Logging.Write(Colors.SandyBrown, "[BuyCoke v" + Version.ToString() + "] Buying.");
								GrandCompanyExchangeWindow.BuyItem();									
								Status = 0;
							})  
                        ),						
                        new Decorator(r => Vector3.Distance(Core.Player.Location, NpcLocation) <= 2,
                            new PrioritySelector(
                                
                                new Decorator(r => SelectYesno.IsOpen,
                                    new Action(r => SelectYesno.ClickYes())
                                ),
                                
                                new Decorator(r => WorldManager.ZoneId == 130 && Status == 0,
                                    new Action(r =>
                                    {
                                        Logging.Write(Colors.SandyBrown, "[BuyCoke v" + Version.ToString() + "] Approaching NPC...");
                                        GameObjectManager.GetObjectByNPCId(NpcId).Interact();
                                    })
                                ),
                                new ActionAlwaysSucceed()
                            )
                        ),
                        new Decorator(r => Status == 0 && WorldManager.ZoneId == 130 && Vector3.Distance(Core.Player.Location, NpcLocation) > 2,
                            CommonBehaviors.MoveAndStop(r => NpcLocation, 2f, true, "Going to NPC")
                        ),
                        new Decorator(r => Status == 0 && WorldManager.ZoneId != 130,
                            new PrioritySelector(                                
                                new Decorator(r => WorldManager.ZoneId != 130,
                                    new Sequence(
                                        new Action(r =>
                                        {
                                            if (!WorldManager.HasAetheryteId(9))
                                            {
                                                Logging.Write(Colors.SandyBrown, "[BuyCoke v" + Version.ToString() + "] Missing aetheryte.....");
                                                TreeRoot.Stop();
                                            }
                                            if (!Core.Player.IsCasting)
                                            {
                                                WorldManager.TeleportById(9);
                                            }
                                        }),
                                        new Sleep(9)
                                    )
                                )
                            )
                        )
                    )
                );
            }
        }
    }
	
	public class GCESelectyesno
    {
        public static bool IsOpen
        {
            get
            {
                return RaptureAtkUnitManager.GetWindowByName("SelectYesno") != null;
            }
        }

        public static void ClickOk()
        {
            var window = RaptureAtkUnitManager.GetWindowByName("SelectYesno");
            if(window != null)
            {
                window.SendAction(1,3,0);
            }
        }
		
	}
	
	
	public class GrandCompanyExchangeWindow
    {
        public static bool IsOpen
        {
            get
            {
                return RaptureAtkUnitManager.GetWindowByName("GrandCompanyExchange") != null;
            }
        }

        public static void MoveToTab()
        {
            var window = RaptureAtkUnitManager.GetWindowByName("GrandCompanyExchange");
            if(window != null)
            {
                window.SendAction(2, 1, 1, 2, 2);
            }
        }

        public static void MoveToType()
        {
            var window = RaptureAtkUnitManager.GetWindowByName("GrandCompanyExchange");
            if (window != null)
            {
                window.SendAction(2, 2, 2, 1, 1);  
            }
        }
		
		public static void BuyItem()
        {
            var window = RaptureAtkUnitManager.GetWindowByName("GrandCompanyExchange");
            if (window != null)
            {
                window.SendAction(2,1,0,1,4);   
            }
        }
		
		
		public static void CloseWindow()
        {
            var window = RaptureAtkUnitManager.GetWindowByName("GrandCompanyExchange");
            if (window != null)
            {
                window.SendAction(1, 3, 0xFFFFFFFF);  
            }
        }
		
    }
}
